/*-----------------------------------------------------------------------------
gumb_strucs.h

Shyam Prabhakar Oct 5 2001

Definitions of new data types used in mbgumbel.c, and programs that call the
functions declared in mbgumbel.h.
-----------------------------------------------------------------------------*/

#ifndef GUMB_STRUCS
#define GUMB_STRUCS

/* statistical parameters relating to letter scores and the
extreme-value distribution of aggregate segment scores */
typedef struct
{

  double avg, sigma2;  /* mean and variance of letter scores */
  double lambda, K;    /* parameters of Gumbel distribution  */

  double base_ratio;   /* ratio of baseline "neutral" alignment
			  columns to base-sequence positions. */

} GUMB_STATS;

#endif
