/*-----------------------------------------------------------------------------
tree_ops.c

Shyam Prabhakar Aug 04 2003
-----------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "tree_strucs.h"
#include "read_file.h"

#define FILE_CHUNK_SIZ 10


char **get_species(char *str, int *n_spec_ptr)
{

  int n_spec = 0;
  char *spec_name, **spec_names;

  spec_names = (char **) malloc(0);

  while ( spec_name = chew_first_word(&str, 'l') )
    {
      spec_names = (char **) realloc(spec_names, (n_spec + 1)*sizeof(char *) );
      spec_names[n_spec++] = spec_name;
    }

  *n_spec_ptr = n_spec;

  return n_spec ? spec_names : 0;

}


PHYLO_TREE *read_tree(char *fname)
{

  char *file_contents;
  int f_len;
  PHYLO_TREE *tree_ptr = 0;

  if ( !(file_contents = read_file(fname, &f_len, FILE_CHUNK_SIZ)) )
    fprintf(stderr, "no such tree file!\n");
  else if (!f_len)
    fprintf(stderr, "empty tree file!\n");
  else
    {
      tree_ptr         = (PHYLO_TREE *) calloc(1, sizeof(PHYLO_TREE));
      tree_ptr->leaves = get_species(file_contents, &tree_ptr->nleaf);

      if (tree_ptr->nleaf < 2)
	{
	  fprintf(stderr, "tree file has less than two leaves ... ignore!\n");
	  free(tree_ptr);
	  tree_ptr = 0;
	}
    }

  return tree_ptr;

}
